/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : pon kwi 14 18:06:02 CEST 2003
    copyright            : (C) 2003 by Bartosz Lis
    email                : bartoszl@ics.p.lodz.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <stdlib.h>

#include <ann_cybenko.h>
#include <ann_grad_weight.h>
#include <ann_log_io.h>
#include <ann_term.h>
#include <ann_ds_ws.h>
#include <ann_ds_tee.h>
#include <ann_ds_out.h>
#include <ann_trainer.h>
#include <ann_log_lazy.h>
#include <fstream>

int main(int argc, char *argv[])
{
  size_t sizes[] = {6,ANN::size_max};
  ANN::Term t(sizes);
  size_t i, l=t.get_size();
  for (i=0; i<l; ++i) t[i]=i;
  {
    ANN::LogIO log(std::cout);
    ANN::LogLazy lazy(log);
    {
      std::ifstream fdata("test.txt");
      log.nl("wczytuj").flush();
      {
        ANN::DS_ws ds_ws(fdata);
        log.nl("wczytaem").flush();
        for (i=0; i<4; ++i)
        {
          log.log(ds_ws.term(),"wzorzec wejciowy");
          if (ds_ws.des_output()) log.log(ds_ws.des_output()->term(),"wzorzec wyjciowy");
          ds_ws.next();
        }
        log.nl("Tworz wagi").flush();        
        ANN::GradWeight_Cmn            gr_wg_cmn(log,10);
        ANN::GradWeight_Grp::Factory_t gr_wg_f(gr_wg_cmn);
        ANN::GradWeight::Common_t      gr_w_cmn(gr_wg_f);
        ANN::GradWeight_Fact           gr_w_f(gr_w_cmn);
        log.nl("Tworz Cybenk").flush();
        ANN::Multilayer *sample=ANN::create_Cybenko("sie_cybenki",4,2,4,gr_w_f,false);
        log << sample->get_out_sizes().dim() << sample->get_out_size();
        log.nl("Tworz trenera").flush();
        ANN::Trainer trainer(ds_ws);
        log << ds_ws.get_sizes().dim() << ds_ws.get_size();
        log.nl("Przyczepiam Cybenk do trenera: ").flush();
        log << trainer.act_on(*sample);
        log.nl("Losuj wagi: ").flush();
        trainer.randomize();
        log.nl("W drog: ").flush();
        log << trainer.train(1000,.01);
        log.nl("Tworz rdo wyjciowe").flush();
        ANN::DS_out ds_out(ds_ws,*sample);
        log.nl("wi").flush();
        {
          ANN::DS_tee ds_tee(ds_out,log,"wynik");
          log.nl("zaczynam").flush();;
          ds_tee.reset();
          log.nl("krc").flush();
          for (i=0; i<8; ++i) ds_tee.next(); 
          log.nl("Niszcze DS_tee").flush();
        } 
        log.nl("Niszcze Cybenke").flush();
        delete sample;
        log.nl("Niszcze DS_ws").flush();
      }
      log.nl("niszcze plik").flush();
    }
    log.nl("niszcze loga").flush();
  }      
  std::cout << "koniec" << std::endl << std::flush;
  return EXIT_SUCCESS;  
}
