/***************************************************************************
                          ann_cybenko.h  -  description
                             -------------------
    begin                : pon kwi 14 2003
    copyright            : (C) 2003 by Bartosz Lis
    email                : bartoszl@ics.p.lodz.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __ANN_CYBENKO_H
#define __ANN_CYBENKO_H

#include <ann_weight.h>
#include <ann_perceptron.h>
#include <ann_multilayer.h>

namespace ANN
{

  Multilayer *
  create_Cybenko(const char *label, size_t in, size_t hidden, size_t out,
                 WeightFactoryBase &w,
                 Perceptron::Activation &act=Perceptron::sigmoidal,
                 bool bias=true);
  inline Multilayer *
  create_Cybenko(const char *label, size_t in, size_t hidden, size_t out,
                 WeightFactoryBase &w, bool bias)
  { return create_Cybenko(label,in,hidden,out,w,Perceptron::sigmoidal,bias); }
  Multilayer *
  create_Cybenko(size_t in, size_t hidden, size_t out, WeightFactoryBase &w,
                 Perceptron::Activation &act=Perceptron::sigmoidal,
                 bool bias=true)
  { return create_Cybenko(0,in,hidden,out,w,act,bias); }
  inline Multilayer *
  create_Cybenko(size_t in, size_t hidden, size_t out, WeightFactoryBase &w,
                 bool bias)
  { return create_Cybenko(0,in,hidden,out,w,Perceptron::sigmoidal,bias); }

} //namespace ANN

#endif /* __ANN_CYBENKO_H */

