/***************************************************************************
                          ann_init.h  -  description
                             -------------------
    begin                : wto kwi 22 2003
    copyright            : (C) 2003 by Bartosz Lis
    email                : bartoszl@ics.p.lodz.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __ANN_INIT_H
#define __ANN_INIT_H

#include <ctype.h>

#include <ann_loc.h>

namespace ANN
{

  class Init;
  
  //             //
 // struct Init //
//             //

  class Init
  {
  private:
    Init();
    
  protected:  
    char   *buffer;
    size_t  len;
    size_t  cap;

  public:  
    const Size *size;

    Init(const Size &size_, const char *label_);
    Init(const Init &that);
    virtual ~Init();
        
    const char *label() const { return buffer; }
    char       *dup_label () const;
    size_t      length() const { return len; }
    void        resize(size_t capacity_);
    void        set_label(const char *label, size_t pos=0);
    void        set_index(size_t index, size_t pos=0);
  };

} // namespace ANN

#endif /* __ANN_INIT_H */
