/***************************************************************************
                          ann_log_io.h  -  description
                             -------------------
    begin                : pon kwi 14 2003
    copyright            : (C) 2003 by Bartosz Lis
    email                : bartoszl@ics.p.lodz.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __ANN_LOG_IO_H
#define __ANN_LOG_IO_H

#include <iostream>
#include <ann_log.h>

namespace ANN
{

  class LogIO;
  
  //             //
 // class LogIO //
//             //
  class LogIO : public Log
  {
  private:
    LogIO();
    LogIO(const LogIO &that);
    
  protected:
    std::ostream  *os;
    int            marg;
    Clock         *clock;
    Clock::Buffer  stamp;
    char           sep, sub_beg, sub_end;
    bool           is_first;

    void          write_sep();
    virtual void  new_line(int ch_marg, const char *label);
    virtual void  log_chr(char chr);
    virtual void  log_str(const char *str);
    virtual void  log_int(int i);
    virtual void  log_uint(unsigned int u);
    virtual void  log_double(double d);

  public:
    LogIO(std::ostream &os_, const char sep_=' ', char sub_beg_='{',
          char sub_end_='}');
    LogIO(Clock &clock_, std::ostream &os_, const char sep_=' ',
          char sub_beg_='{', char sub_end_='}');
    virtual ~LogIO();

    virtual Clock  &get_clock() const;
    virtual char    get_separator() const;
    virtual char    get_sublevel_beg() const;
    virtual char    get_sublevel_end() const;
    virtual size_t  get_margin() const;
    virtual Log    &flush();
  };

} // namespace ANN

#endif /* __ANN_LOG_IO_H */
