/***************************************************************************
                          ann_log_lazy.h  -  description
                             -------------------
    begin                : pon kwi 14 2003
    copyright            : (C) 2003 by Bartosz Lis
    email                : bartoszl@ics.p.lodz.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __ANN_LOG_LAZY_H
#define __ANN_LOG_LAZY_H

#include <ctype.h>

#include <ann_log.h>

namespace ANN
{

  class LogLazy;

  //               //
 // class LogLazy //
//               //

  class LogLazy : public LogRec
  {
  private:
    LogLazy();
    
  protected:
    size_t  epochs;

    virtual void  prop_prepare(size_t epoch);
    virtual void  prop_update(size_t epoch, double error);
    
  public:
    LogLazy(Log &orig_, size_t epochs_=20)
    : LogRec(orig_), epochs(epochs_) {}
    virtual ~LogLazy();

  };

} // namespace ANN

#endif /* __ANN_LOG_LAZY_H */
