/***************************************************************************
                          ann_lstore_set.h  -  description
                             -------------------
    begin                : pon kwi 14 2003
    copyright            : (C) 2003 by Bartosz Lis
    email                : bartoszl@ics.p.lodz.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __ANN_LSTORE_SET_H
#define __ANN_LSTORE_SET_H

#include <set>

#include <cmp_ptr.h>
#include <ann_log.h>

namespace ANN
{

  class Lstore_set;

  //              //
 // class Lstore //
//              //

  class Lstore_set : public Lstore
  {
  protected:
    typedef std::set<LogRec *,CmpPtr> LogSet;
    typedef LogSet::iterator          Iterator;

    LogSet                            children;
    
  public:
    Lstore_set() {}
    virtual ~Lstore_set();

    virtual bool  attach(LogRec &child);
    virtual bool  detach(LogRec &child);
    virtual void  reset();
    virtual void  prepare(size_t epoch);
    virtual void  stepped(size_t num, double error);
    virtual void  update(size_t epoch, double error);
  };

} // namespace ANN

#endif /* __ANN_LSTORE_SET_H */
