/***************************************************************************
                          ann_wcommon.h  -  description
                             -------------------
    begin                : wto kwi 22 2003
    copyright            : (C) 2003 by Bartosz Lis
    email                : bartoszl@ics.p.lodz.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __ANN_WCOMMON_H
#define __ANN_WCOMMON_H

#include <ann_weight.h>
#include <ann_factory.h>

namespace ANN
{

  template <class WG, class Instance=typename WG::Instance_t>
  class Wcommon;

  //template <class WG, class Instance>//
 // class Wcommon                     //
//                                   //

  template <class WG, class Instance>
  class Wcommon
  {
  private:
    Wcommon();

  public:
    typedef WG                        WGBase_t;
    typedef FactoryBase<WG,Instance>  WGFactory_t;

    WGBase_t    *wg;
    WGFactory_t *wgf;

    Wcommon(WGFactory_t &wgf_, WGBase_t *wg_=0) : wg(wg_), wgf(&wgf_) {}
    Wcommon(const Wcommon &that) : wg(that.wg), wgf(that.wgf) {}

    Wcommon &operator = (Wcommon &that) { wg=that.wg; wgf=that.wgf; }
  };

} // namespace ANN

#endif /* __ANN_WCOMMON_H */
