/***************************************************************************
                          ann_wstore_set.h  -  description
                             -------------------
    begin                : czw kwi 17 2003
    copyright            : (C) 2003 by Bartosz Lis
    email                : bartoszl@ics.p.lodz.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __ANN_WSTORE_SET_H
#define __ANN_WSTORE_SET_H

#include <set>

#include <cmp_ptr.h>
#include <ann_weight.h>

namespace ANN {
  
  //                  //
 // class Wstore_set //
//                  //

  class Wstore_set : public Wstore
  {
  public:
    typedef std::set<Weight *,CmpPtr> Weights;
    typedef Weights::iterator         Weights_it;
    typedef std::set<Wgroup *,CmpPtr> Wgroups;
    typedef Wgroups::iterator         Wgroups_it;
    
  private:
    Wstore_set(const Wstore_set &that);

  protected:
    Weights w_set;
    Wgroups g_set;

  public:
    Wstore_set() {}
    virtual ~Wstore_set();

    virtual void register_weight(Weight &w);
    virtual void erase_weights();
    virtual void reset(Trainer &t);       /* resets weight befor training */
    virtual void prepare(Trainer &t);     /* prepares to an epoch */
    virtual void update(Trainer &t);      /* updates value */
    virtual void randomize();             /* randomizes value */
    virtual bool load(Parser_Log &parser, time_t begin=0,
                      time_t end=(time_t)-1); /* loads from a log */
    virtual void store(Log &log);             /* stores to a log */
  };

} // namespace ANN 

#endif /* __ANN_WSTORE_SET_H */
