/***************************************************************************
                          ann_cybenko.cpp  -  description
                             -------------------
    begin                : pon kwi 14 2003
    copyright            : (C) 2003 by Bartosz Lis
    email                : bartoszl@ics.p.lodz.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <ann_cybenko.h>

namespace ANN
{
  Multilayer *
  create_Cybenko(const char *label, size_t in, size_t hidden, size_t out,
                 WeightFactoryBase &w, Perceptron::Activation &act, bool bias)
  {
    Size in_size(1,&in);
    Init inst(in_size,label ? label : "Cybenko_net");
    Perceptron::Param hid_par(&w,&act,bias,1,&hidden);
    Perceptron::Param out_par(&w,&Perceptron::linear,bias,1,&out);
    PerceptronFactory *factory[]=
    {
      new PerceptronFactory(hid_par),
      new PerceptronFactory(out_par),
    };
    return new Multilayer(&inst,factory,factory+2);
  }
} // namespace ANN
