/***************************************************************************
                          ann_element.cpp  -  description
                             -------------------
    begin                : pon kwi 14 2003
    copyright            : (C) 2003 by Bartosz Lis
    email                : bartoszl@ics.p.lodz.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <ann_element.h>

  //                    //
 // class ANN::Element //
//                    //

size_t          single_out_size_arr[] = { 1 };
const ANN::Size ANN::Element::single_out_size(1,single_out_size_arr);

ANN::Element::~Element()
{
}

const ANN::Size &
ANN::Element::get_out_sizes() const
{
  return single_out_size;
}

const size_t
ANN::Element::get_out_size() const
{
  return get_out_sizes().total_size();
}

void
ANN::Element::prepare(Trainer &t)
{
}

void
ANN::Element::update(Trainer &t)
{
}

  //                      //
 // class ANN::Evaluator //
//                      //

ANN::Evaluator::~Evaluator()
{
}

bool
ANN::Evaluator::trivial_match() const
{
  return true;
}

bool
ANN::Evaluator::matching(const Size &out_size, const Size &des_size) const
{
  return out_size.dim() && (out_size.total_size()==des_size.total_size());
}

double
ANN::Evaluator::evaluate_ds(DS &ds, const Term &out, Term &err) const
{
  return evaluate(ds.input()->term(),ds.des_output()->term(),out,err);
}

