/***************************************************************************
                          ann_lstore_set.cpp  -  description
                             -------------------
    begin                : pi kwi 18 2003
    copyright            : (C) 2003 by Bartosz Lis
    email                : bartoszl@ics.p.lodz.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <ann_lstore_set.h>

  //                       //
 // class ANN::Lstore_set //
//                       //

ANN::Lstore_set::~Lstore_set()
{
  Iterator  it;
  LogRec   *log;
  while (!children.empty())
  {
    log=*(it=children.begin());
    children.erase(it);
    delete log;
  }
}

bool
ANN::Lstore_set::attach(LogRec &child)
{
  return children.insert(&child).second;
}

bool
ANN::Lstore_set::detach(LogRec &child)
{
  return children.erase(&child);
}

void
ANN::Lstore_set::reset()
{
  Iterator it=children.begin();
  Iterator end=children.end();
  while (it!=end) (*it++)->reset();
}

void
ANN::Lstore_set::prepare(size_t epoch)
{
  Iterator it=children.begin();
  Iterator end=children.end();
  while (it!=end) (*it++)->prepare(epoch);
}

void
ANN::Lstore_set::stepped(size_t num, double error)
{
  Iterator it=children.begin();
  Iterator end=children.end();
  while (it!=end) (*it++)->stepped(num,error);
}

void
ANN::Lstore_set::update(size_t epoch, double error)
{  
  Iterator it=children.begin();
  Iterator end=children.end();
  while (it!=end) (*it++)->update(epoch,error);
}
