/***************************************************************************
                          ann_wstore_set.cpp  -  description
                             -------------------
    begin                : czw kwi 17 2003
    copyright            : (C) 2003 by Bartosz Lis
    email                : bartoszl@ics.p.lodz.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <ann_wstore_set.h>

  //                   //
 // class ANN::Wstore //
//                   //

ANN::Wstore_set::~Wstore_set()
{
}

void
ANN::Wstore_set::register_weight(Weight &w)
{
  g_set.insert(w.get_group());
  w_set.insert(&w);
}

void
ANN::Wstore_set::erase_weights()
{
  g_set.clear();
  w_set.clear();
}

void
ANN::Wstore_set::reset(Trainer &t)
{
  Wgroups_it git, gend;
  for (git=g_set.begin(), gend=g_set.end(); git!=gend; ++git)
    (*git)->reset(t);
  Weights_it wit, wend;
  for (wit=w_set.begin(), wend=w_set.end(); wit!=wend; ++wit)
    (*wit)->reset(t);
}

void
ANN::Wstore_set::prepare(Trainer &t)
{
  Wgroups_it git, gend;
  for (git=g_set.begin(), gend=g_set.end(); git!=gend; ++git)
    (*git)->prepare(t);
  Weights_it wit, wend;
  for (wit=w_set.begin(), wend=w_set.end(); wit!=wend; ++wit)
    (*wit)->prepare(t);
  for (git=g_set.begin(), gend=g_set.end(); git!=gend; ++git)
    (*git)->prepared(t);
}

void
ANN::Wstore_set::update(Trainer &t)
{
  Wgroups_it git, gend;
  for (git=g_set.begin(), gend=g_set.end(); git!=gend; ++git)
    (*git)->update(t);
  Weights_it wit, wend;
  for (wit=w_set.begin(), wend=w_set.end(); wit!=wend; ++wit)
    (*wit)->update(t);
  for (git=g_set.begin(), gend=g_set.end(); git!=gend; ++git)
    (*git)->updated(t);
}

void
ANN::Wstore_set::randomize()
{
  Weights_it wit, wend;
  for (wit=w_set.begin(), wend=w_set.end(); wit!=wend; ++wit)
    (*wit)->randomize();
}

bool
ANN::Wstore_set::load(Parser_Log &parser, time_t begin, time_t end)
{
  Wgroups_it git, gend;
  for (git=g_set.begin(), gend=g_set.end(); git!=gend; ++git)
    if (!(*git)->load(parser,begin,end)) return false;
  Weights_it wit, wend;
  for (wit=w_set.begin(), wend=w_set.end(); wit!=wend; ++wit)
    if (!(*wit)->load(parser,begin,end)) return false;
  return true;
}

void
ANN::Wstore_set::store(Log &log)
{
  Wgroups_it git, gend;
  for (git=g_set.begin(), gend=g_set.end(); git!=gend; ++git)
    (*git)->store(log);
  Weights_it wit, wend;
  for (wit=w_set.begin(), wend=w_set.end(); wit!=wend; ++wit)
    (*wit)->store(log);
}  

